Name:		hp-iavf
Version:	3.7.61.20
Release:	1.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL-2.0
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	Intel(R) Ethernet Adaptive Virtual Function Driver for HPE systems

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -f %{SOURCE1} -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
This package provides the Intel(R) Ethernet Adaptive Virtual Function Driver for HPE systems.
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: Summary: Intel(R) Ethernet Adaptive Virtual Function Driver for HPE systems
Group: System/Kernel

%description KMP
This package provides the Intel(R) Ethernet Adaptive Virtual Function Driver for HPE systems.
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the Intel(R) Ethernet Adaptive Virtual Function Driver for HPE systems

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "blacklist i40evf" > %{name}.conf
echo "alias i40evf iavf" >> %{name}.conf
echo "add_drivers+=\" iavf \"" > %{name}-oob.conf

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/iavf.7 > source/iavf.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} rpm

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/iavf.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/iavf.7.gz
install -d %{buildroot}%{_sysconfdir}/modprobe.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/modprobe.d/

install -d %{buildroot}%{_sysconfdir}/dracut.conf.d/
install %{name}-oob.conf %{buildroot}%{_sysconfdir}/dracut.conf.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/iavf.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/modprobe.d/%{name}.conf
%{_sysconfdir}/dracut.conf.d/%{name}-oob.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/iavf.7.gz
%doc source/COPYING source/README

%changelog
* Fri Oct 04 2019 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
- Initial package which is renamed from i40evf driver
